Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 397760)
+++ channels/chan_sip.c	(revision 397761)
@@ -9419,7 +9419,7 @@
 
 	/* Setup audio address and port */
 	if (p->rtp) {
-		if (portno > 0) {
+		if (sa && portno > 0) {
 			ast_sockaddr_set_port(sa, portno);
 			ast_rtp_instance_set_remote_address(p->rtp, sa);
 			if (debug) {
@@ -9466,7 +9466,7 @@
 
 	/* Setup video address and port */
 	if (p->vrtp) {
-		if (vportno > 0) {
+		if (vsa && vportno > 0) {
 			ast_sockaddr_set_port(vsa, vportno);
 			ast_rtp_instance_set_remote_address(p->vrtp, vsa);
 			if (debug) {
@@ -9483,7 +9483,7 @@
 
 	/* Setup text address and port */
 	if (p->trtp) {
-		if (tportno > 0) {
+		if (tsa && tportno > 0) {
 			ast_sockaddr_set_port(tsa, tportno);
 			ast_rtp_instance_set_remote_address(p->trtp, tsa);
 			if (debug) {
@@ -9506,7 +9506,7 @@
 
 	/* Setup image address and port */
 	if (p->udptl) {
-		if (udptlportno > 0) {
+		if (isa && udptlportno > 0) {
 			if (ast_test_flag(&p->flags[1], SIP_PAGE2_SYMMETRICRTP) && ast_test_flag(&p->flags[1], SIP_PAGE2_UDPTL_DESTINATION)) {
 				ast_rtp_instance_get_remote_address(p->rtp, isa);
 				if (!ast_sockaddr_isnull(isa) && debug) {

Property changes on: .
___________________________________________________________________
Modified: branch-1.8-merged
   - /branches/1.8:1-369936,369938-369969,369971-369992,369994-370013,370015-370016,370018-370080,370082-370130,370132-370182,370184-370251,370253-370382,370384-370427,370430-370493,370495-370641,370643-370665,370667-370696,370698-370769,370772-370796,370798-370855,370857-370899,370901-370922,370924-370951,370953-370984,370986-370987,370989-371010,371013-371059,371061-371088,371090-371197,371199-371269,371271-371305,371307-371391,371393-371543,371545-371589,371591-371661,371663-371689,371691-371717,371719-371823,371825-371887,371889-371918,371920-371960,371962-372047,372049-372088,372090-372157,372159-372211,372213-372238,372240-372267,372269-372336,372338,372340-372353,372355-372389,372391-372416,372418-372443,372445-372470,372472-372497,372499-372516,372518-372553,372555-372580,372582-372619,372621-372623,372625-372654,372656-372681,372683-372735,372737-372762,372764,372766-372803,372805-372839,372841-372901,372903-372931,372933-372958,372960-373023,373025-373089,373091-373130,373132-373235,373237-373241,373243-373297,373299-373341,373343-373423,373425-373437,373439-373466,373468-373499,373501-373503,373505-373549,373551-373577,373579-373616,373619-373639,373641-373665,373667-373701,373703-373704,373706-373734,373736-373772,373774-373814,373816-373847,373849-373877,373879-373908,373910-373988,373990-374031,374033-374107,374109-374176,374178-374229,374231-374315,374317-374334,374336-374364,374366-374383,374385-374425,374427-374474,374476-374478,374480-374536,374802,374843,375216-375243,375245-375271,375273-375324,375326-375361,375625,376950,378269,378303,378933,379001,382227,388425,396958,397710
   + /branches/1.8:1-369936,369938-369969,369971-369992,369994-370013,370015-370016,370018-370080,370082-370130,370132-370182,370184-370251,370253-370382,370384-370427,370430-370493,370495-370641,370643-370665,370667-370696,370698-370769,370772-370796,370798-370855,370857-370899,370901-370922,370924-370951,370953-370984,370986-370987,370989-371010,371013-371059,371061-371088,371090-371197,371199-371269,371271-371305,371307-371391,371393-371543,371545-371589,371591-371661,371663-371689,371691-371717,371719-371823,371825-371887,371889-371918,371920-371960,371962-372047,372049-372088,372090-372157,372159-372211,372213-372238,372240-372267,372269-372336,372338,372340-372353,372355-372389,372391-372416,372418-372443,372445-372470,372472-372497,372499-372516,372518-372553,372555-372580,372582-372619,372621-372623,372625-372654,372656-372681,372683-372735,372737-372762,372764,372766-372803,372805-372839,372841-372901,372903-372931,372933-372958,372960-373023,373025-373089,373091-373130,373132-373235,373237-373241,373243-373297,373299-373341,373343-373423,373425-373437,373439-373466,373468-373499,373501-373503,373505-373549,373551-373577,373579-373616,373619-373639,373641-373665,373667-373701,373703-373704,373706-373734,373736-373772,373774-373814,373816-373847,373849-373877,373879-373908,373910-373988,373990-374031,374033-374107,374109-374176,374178-374229,374231-374315,374317-374334,374336-374364,374366-374383,374385-374425,374427-374474,374476-374478,374480-374536,374802,374843,375216-375243,375245-375271,375273-375324,375326-375361,375625,376950,378269,378303,378933,379001,382227,388425,396958,397710,397756